
/*

 This software is in the public domain, furnished "as is", without technical  
 support, and with no warranty, express or implied, as to its usefulness for  
 any purpose.                 
                                                                          
 First demo program for using a DAC MCP4725 to control a RC transmitter  
  
 This demo just sends a view commands to move a servo as an example.

 Author: Dirk Wiedemann                                    
 Date: 2018/05/15                                       
 
 This sketch uses the library MyMCP4725 from Retian.                                               
 
*/

#include <Wire.h>
#include <MyMCP4725.h>

#define potiPin 0
#define i2cAdress 0x60

MyMCP4725 DAC(i2cAdress);

int Wert;
volatile uint16_t potiWert;
unsigned long startTime, endTime;
bool dacStatus = false;


void setup() {
  //Serial.begin(115200); 		//serial-commands only for debugging
  if (DAC.isReady())
  {
    //Serial.println("\nDAC in Ordnung!"); 		//serial-commands only for debugging
    dacStatus = true;
    DAC.setWireClock(400);                      //setting I2C frequence to 400 kHz
  }
  //else Serial.println("DAC Fehler!"); 		//serial-commands only for debugging
}


void loop() {
  if (dacStatus) {
    for(int i=0; i<100; i++){    
        Wert = i * 1;
        setDAC(Wert);
        delay(50);
    }   
    for(int i=100; i>0; i--){    
        Wert = i * 1;
        setDAC(Wert);
        delay(50);
    }
    setDAC(100);
    delay(1000);
    setDAC(50);
    delay(1000);
    setDAC(100);
    delay(1000);
    setDAC(0);
    delay(1000);
    setDAC(50);
    delay(1000);
    setDAC(0);
    delay(1000);
  }
}

void setDAC(int Prozent) {
    potiWert = map(Prozent, 0, 100, 0, 4095);  // mapping procent value to 12 bit resolution 
    startTime = micros();
    DAC.setVoltage(potiWert, false); //setting the DAC; false = EEPROM wasn't written
    endTime = micros();

}

